sub duplo_ui_ui_ui()

 REM		$Id$

 REM	Copyright (c) New Deal 1997 -- All Rights Reserved

 REM	FILE:		STDINC.BH



 STRUCT TimeOfDay

  DIM hour as integer

  DIM minute as integer

  DIM second as integer

 END STRUCT



 STRUCT Date

  DIM year as integer

  DIM month as integer

  DIM day as integer

 END STRUCT



 STRUCT Notification

  DIM arg1 as integer

  DIM arg2 as integer

  DIM arg3 as integer

  DIM arg4 as integer

  DIM arg5 as string

  DIM arg6 as complex

 END STRUCT



REM useful color constants

CONST WHITE 		&Hffffffff

CONST BLACK 		&Hff000000

CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080

CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa

CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa

CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55

CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff

CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff

CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff

CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555

CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55



REM useful text style constants

CONST UNDERLINE		1

CONST STRIKE_THRU	2

CONST SUBSCRIPT		4

CONST SUPERSCRIPT	8

CONST ITALIC		16

CONST BOLD		32



REM useful Boolean constants

CONST TRUE		1

CONST FALSE		0



REM sound constants

CONST SS_ERROR		0

CONST SS_WARNING	1

CONST SS_NOTIFY		2

CONST SS_NO_INPUT	3

CONST SS_KEY_CLICK	4

CONST SS_ALARM		5



CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5

CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7



CONST C_SYS_00			&Hff00

CONST C_SYS_FF			&Hffff

CONST C_SYS_BACKSPACE		&Hff08

CONST C_SYS_TAB			&Hff09

CONST C_SYS_ENTER		&Hff0d

CONST C_SYS_ESCAPE		&Hff1b

CONST C_SYS_F1			&Hff80

CONST C_SYS_F2			&Hff81

CONST C_SYS_F3			&Hff82

CONST C_SYS_F4			&Hff83

CONST C_SYS_F5			&Hff84

CONST C_SYS_F6			&Hff85

CONST C_SYS_F7			&Hff86

CONST C_SYS_F8			&Hff87

CONST C_SYS_F9			&Hff88

CONST C_SYS_F10			&Hff89

CONST C_SYS_F11			&Hff8a

CONST C_SYS_F12			&Hff8b

CONST C_SYS_F13			&Hff8c

CONST C_SYS_F14			&Hff8d

CONST C_SYS_F15			&Hff8e

CONST C_SYS_F16			&Hff8f

CONST C_SYS_UP			&Hff90

CONST C_SYS_DOWN		&Hff91

CONST C_SYS_RIGHT		&Hff92

CONST C_SYS_LEFT		&Hff93

CONST C_SYS_HOME		&Hff94

CONST C_SYS_END			&Hff95

CONST C_SYS_PREVIOUS		&Hff96

CONST C_SYS_NEXT		&Hff97

CONST C_SYS_INSERT		&Hff98

CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.

CONST C_SYS_DELETE		&Hff9a

CONST C_SYS_PRINT_SCREEN	&Hff9b

CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.

CONST C_SYS_BREAK		&Hff9e

CONST C_SYS_CAPS_LOCK		&Hffe8

CONST C_SYS_NUM_LOCK		&Hffe9

CONST C_SYS_SCROLL_LOCK		&Hffea

CONST C_SYS_LEFT_ALT		&Hffe0

CONST C_SYS_RIGHT_ALT		&Hffe1

CONST C_SYS_LEFT_CTRL		&Hffe2

CONST C_SYS_RIGHT_CTRL		&Hffe3

CONST C_SYS_LEFT_SHIFT		&Hffe4

CONST C_SYS_RIGHT_SHIFT		&Hffe5





CONST KEY_BS 		&Hff08

CONST KEY_DEL 		&Hff9a

CONST KEY_ENTER 	&Hff0d

CONST KEY_KP_RETURN 	&Hffff

CONST KEY_HOME		&Hff94

CONST KEY_TAB		&Hff09

CONST KEY_END		&Hff93

CONST KEY_ESC		&Hff1b

CONST KEY_UP_ARROW	&Hff90

CONST KEY_LEFT_ARROW	&Hff93

CONST KEY_RIGHT_ARROW	&Hff92

CONST KEY_DOWN_ARROW	&Hff91



REM date formats

CONST DTF_LONG				0

CONST DTF_LONG_CONDENSED		1

CONST DTF_LONG_NO_WEEKDAY		2

CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3

CONST DTF_SHORT				4

CONST DTF_ZERO_PADDED_SHORT		5

CONST DTF_MD_LONG			6

CONST DTF_MD_LONG_NO_WEEKDAY		7

CONST DTF_MD_SHORT			8

CONST DTF_MY_LONG			9

CONST DTF_MY_SHORT			10

CONST DTF_YEAR				11

CONST DTF_MONTH				12

CONST DTF_DAY				13

CONST DTF_WEEKDAY			14

REM time formats

CONST DTF_HMS				15

CONST DTF_HM				16

CONST DTF_H				17

CONST DTF_MS				18

CONST DTF_HMS_24HOUR			19

CONST DTF_HM_24HOUR			20



REM pi

CONST PI 3.14159265359



REM Format() constants

CONST FFAF_SCIENTIFIC		&H100

CONST FFAF_PERCENT		&H80

CONST FFAF_USE_COMMAS		&H40

CONST FFAF_NO_TRAIL_ZEROS	&H20

CONST FFAF_NO_LEAD_ZERO		&H10



REM dim system as module

REM system = SystemModule()



 REM end of stdinc.bh



DisableEvents()

Dim form1 as form

form1 = MakeComponent("form","app")

CompInit form1

proto="form1"

top=94

left=99

sizeVControl=0

tile=1

tileSpacing=2

caption="Select A Cell ..."

tileHAlign=2

helpContext=""

helpFile=""

End CompInit

Dim group1 as group

group1 = MakeComponent("group",form1)

CompInit group1

proto="group1"

caption="[   ]"

look=1

tile=1

tileLayout=1

tileSpacing=2

sizeHControl=0

sizeVControl=3

width=241

tileHAlign=1

enabled=0

tileVAlign=3

visible=1

End CompInit

Dim button1 as button

button1 = MakeComponent("button",group1)

CompInit button1

proto="button1"

caption="change"

sizeHControl=3

sizeVControl=0

height=16

visible=1

End CompInit

button1.name="button1"

Dim entry1 as entry

entry1 = MakeComponent("entry",group1)

CompInit entry1

proto="entry1"

visible=1

End CompInit

entry1.name="entry1"

Dim group2 as group

group2 = MakeComponent("group",group1)

CompInit group2

proto="group2"

caption="group2"

look=1

tile=1

enabled=0

sizeHControl=3

sizeVControl=3

End CompInit

Dim number1 as number

number1 = MakeComponent("number",group2)

CompInit number1

proto="number1"

caption=""

look=1

sizeHControl=3

sizeVControl=3

enabled=0

maximum=55

displayFormat=2

visible=1

End CompInit

number1.name="number1"

group2.name="group2"

group1.name="group1"

Dim group3 as group

group3 = MakeComponent("group",form1)

CompInit group3

proto="group3"

caption=""

look=1

tile=1

sizeHControl=3

sizeVControl=3

visible=1

End CompInit

Dim table1 as table

table1 = MakeComponent("table",group3)

CompInit table1

proto="table1"

width=550

height=90

numRows=5

numColumns=10

defaultRowHeight=18

look=3

selectionType=1

End CompInit

Dim scrollbar1 as scrollbar

scrollbar1 = MakeComponent("scrollbar",table1)

CompInit scrollbar1

proto="scrollbar1"

left=0

top=76

sizeVControl=0

look=2

sizeHControl=0

width=537

height=18

visible=1

End CompInit

scrollbar1.name="scrollbar1"

Dim scrollbar2 as scrollbar

scrollbar2 = MakeComponent("scrollbar",table1)

CompInit scrollbar2

proto="scrollbar2"

left=537

top=0

sizeHControl=0

sizeVControl=0

width=24

height=76

visible=1

End CompInit

scrollbar2.name="scrollbar2"

table1.name="table1"

table1.rowHeights[4]=18

table1.rowHeights[3]=18

table1.rowHeights[2]=18

table1.rowHeights[1]=18

table1.rowHeights[0]=18

table1.columnWidths[9]=55

table1.columnWidths[8]=55

table1.columnWidths[7]=55

table1.columnWidths[6]=55

table1.columnWidths[5]=55

table1.columnWidths[4]=55

table1.columnWidths[3]=55

table1.columnWidths[2]=55

table1.columnWidths[1]=55

table1.columnWidths[0]=55

table1.visible=1

group3.name="group3"

form1.width=568

form1.height=200

form1.name="form1"

form1.focus=table1

Dim DataSetDB as database

DataSetDB = MakeComponent("database","app")

CompInit DataSetDB

proto="DataSet"

End CompInit

DataSetDB.name="DataSetDB"

EnableEvents()

duplo_start()

end sub



sub duplo_start()

DIM TABELLE [10,5]	AS STRING

DIM ICount 			AS INTEGER

DIM JCount				AS INTEGER







FOR ICount = 1 to 9 STEP 1



	TABELLE [ICount,0] = "   " + CHR(64+ICount) REM Spaltenberschriften



	FOR JCount = 1 TO 4 STEP 1



	       TABELLE [0,JCount]		=	"     " + STR(JCount)	REM Zeilennummer



			TABELLE [ICount,JCount]	= "."			



	NEXT JCount



NEXT ICount



REM Vorgabeauswahl ist A1

table1.SetSelection (1,1,1,1)





end sub



sub module_goTo(context as string)



end sub



function module_getContext()



module_getContext = ""



end function



sub module_show()

REM code for making this module appear

form1.visible=1



end sub



sub module_hide()

REM code for making this module disappear

form1.visible=0



end sub



sub module_exit()



end sub



sub table1_drawCell(self as table, row as integer, column as integer, x as integer, y as integer)

table1.DrawText (TABELLE[column,row] , x + 2 , y + 2 , BLACK , "." , 10 , 0)

end sub



sub table1_selectionChanged(self as table)





REM Spaltenkpfe und Reihenanfang sind on der Selektion ausgeschlossen,

REM heit knnen nicht gendert werden



IF table1.leftColumn > 0 AND table1.topRow > 0 THEN



	REM Anzeige von Reihe und Spalte in group1.caption

	group1.caption = CHR (64 + table1.leftColumn) + STR(table1.topRow)



	REM Eingaben sind nur mglich wenn vorher eine Zelle gewhlt wurde

	group1.enabled 	= TRUE

	number1.enabled 	= TRUE

	

	entry1.text = TABELLE [table1.leftColumn, table1.topRow]

	group2.caption = "Column " + STR(table1.leftColumn) + " width"

	number1.value = table1.columnWidths[table1.leftColumn]



ELSE



	group1.enabled 	= FALSE

	number1.enabled 	= FALSE



END iF



end sub



sub button1_pressed(self as button)



TABELLE [table1.leftColumn,table1.topRow] = entry1.text

table1.Redraw()

end sub



sub table1_aboutToDraw(self as table)



end sub



sub table1_draw(self as table)

DIM Count		AS INTEGER

DIM ColSum		AS INTEGER

DIM RowSum		AS INTEGER







FOR Count = 0 TO self.numRows STEP 1

RowSum = RowSum + self.defaultRowHeight

self.DrawHLine ( 0 , self.width   , RowSum      , BLACK )

NEXT Count



FOR Count = 0 TO table1.numColumns - 1 STEP 1

ColSum = ColSum + table1.columnWidths[Count]

table1.DrawVLine ( 0 , table1.height , ColSum , BLACK)

NEXT Count









end sub



sub number1_changed(self as number, value as integer)



DIM dummy AS INTEGER

dummy = table1.columnWidths[table1.leftColumn] REM Ursprungsbreite merken

table1.columnWidths[table1.leftColumn] = number1.value



end sub



sub entry1_entered(self as entry)

button1_pressed(button1)

end sub



function table1_char(self as table, action as integer, char as integer, modifierState as integer) as integer

IF char = KEY_RIGHT_ARROW THEN

entry1.text =STR(table1.leftColumn +1 )

table1.SetSelection (table1.leftColumn  + 1, table1.topRow, table1.leftColumn + 1,table1.topRow)

END IF

end function



