sub duplo_ui_ui_ui()

 REM		$Id$

 REM	Copyright (c) New Deal 1997 -- All Rights Reserved

 REM	FILE:		STDINC.BH



 STRUCT TimeOfDay

  DIM hour as integer

  DIM minute as integer

  DIM second as integer

 END STRUCT



 STRUCT Date

  DIM year as integer

  DIM month as integer

  DIM day as integer

 END STRUCT



 STRUCT Notification

  DIM arg1 as integer

  DIM arg2 as integer

  DIM arg3 as integer

  DIM arg4 as integer

  DIM arg5 as string

  DIM arg6 as complex

 END STRUCT



REM useful color constants

CONST WHITE 		&Hffffffff

CONST BLACK 		&Hff000000

CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080

CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa

CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa

CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55

CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff

CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff

CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff

CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555

CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55



REM useful text style constants

CONST UNDERLINE		1

CONST STRIKE_THRU	2

CONST SUBSCRIPT		4

CONST SUPERSCRIPT	8

CONST ITALIC		16

CONST BOLD		32



REM useful Boolean constants

CONST TRUE		1

CONST FALSE		0



REM sound constants

CONST SS_ERROR		0

CONST SS_WARNING	1

CONST SS_NOTIFY		2

CONST SS_NO_INPUT	3

CONST SS_KEY_CLICK	4

CONST SS_ALARM		5



CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5

CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7



CONST C_SYS_00			&Hff00

CONST C_SYS_FF			&Hffff

CONST C_SYS_BACKSPACE		&Hff08

CONST C_SYS_TAB			&Hff09

CONST C_SYS_ENTER		&Hff0d

CONST C_SYS_ESCAPE		&Hff1b

CONST C_SYS_F1			&Hff80

CONST C_SYS_F2			&Hff81

CONST C_SYS_F3			&Hff82

CONST C_SYS_F4			&Hff83

CONST C_SYS_F5			&Hff84

CONST C_SYS_F6			&Hff85

CONST C_SYS_F7			&Hff86

CONST C_SYS_F8			&Hff87

CONST C_SYS_F9			&Hff88

CONST C_SYS_F10			&Hff89

CONST C_SYS_F11			&Hff8a

CONST C_SYS_F12			&Hff8b

CONST C_SYS_F13			&Hff8c

CONST C_SYS_F14			&Hff8d

CONST C_SYS_F15			&Hff8e

CONST C_SYS_F16			&Hff8f

CONST C_SYS_UP			&Hff90

CONST C_SYS_DOWN		&Hff91

CONST C_SYS_RIGHT		&Hff92

CONST C_SYS_LEFT		&Hff93

CONST C_SYS_HOME		&Hff94

CONST C_SYS_END			&Hff95

CONST C_SYS_PREVIOUS		&Hff96

CONST C_SYS_NEXT		&Hff97

CONST C_SYS_INSERT		&Hff98

CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.

CONST C_SYS_DELETE		&Hff9a

CONST C_SYS_PRINT_SCREEN	&Hff9b

CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.

CONST C_SYS_BREAK		&Hff9e

CONST C_SYS_CAPS_LOCK		&Hffe8

CONST C_SYS_NUM_LOCK		&Hffe9

CONST C_SYS_SCROLL_LOCK		&Hffea

CONST C_SYS_LEFT_ALT		&Hffe0

CONST C_SYS_RIGHT_ALT		&Hffe1

CONST C_SYS_LEFT_CTRL		&Hffe2

CONST C_SYS_RIGHT_CTRL		&Hffe3

CONST C_SYS_LEFT_SHIFT		&Hffe4

CONST C_SYS_RIGHT_SHIFT		&Hffe5





CONST KEY_BS 		&Hff08

CONST KEY_DEL 		&Hff9a

CONST KEY_ENTER 	&Hff0d

CONST KEY_KP_RETURN 	&Hffff

CONST KEY_HOME		&Hff94

CONST KEY_TAB		&Hff09

CONST KEY_END		&Hff93

CONST KEY_ESC		&Hff1b

CONST KEY_UP_ARROW	&Hff90

CONST KEY_LEFT_ARROW	&Hff93

CONST KEY_RIGHT_ARROW	&Hff92

CONST KEY_DOWN_ARROW	&Hff91



REM date formats

CONST DTF_LONG				0

CONST DTF_LONG_CONDENSED		1

CONST DTF_LONG_NO_WEEKDAY		2

CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3

CONST DTF_SHORT				4

CONST DTF_ZERO_PADDED_SHORT		5

CONST DTF_MD_LONG			6

CONST DTF_MD_LONG_NO_WEEKDAY		7

CONST DTF_MD_SHORT			8

CONST DTF_MY_LONG			9

CONST DTF_MY_SHORT			10

CONST DTF_YEAR				11

CONST DTF_MONTH				12

CONST DTF_DAY				13

CONST DTF_WEEKDAY			14

REM time formats

CONST DTF_HMS				15

CONST DTF_HM				16

CONST DTF_H				17

CONST DTF_MS				18

CONST DTF_HMS_24HOUR			19

CONST DTF_HM_24HOUR			20



REM pi

CONST PI 3.14159265359



REM Format() constants

CONST FFAF_SCIENTIFIC		&H100

CONST FFAF_PERCENT		&H80

CONST FFAF_USE_COMMAS		&H40

CONST FFAF_NO_TRAIL_ZEROS	&H20

CONST FFAF_NO_LEAD_ZERO		&H10



REM dim system as module

REM system = SystemModule()



 REM end of stdinc.bh



DisableEvents()

Dim form1 as form

form1 = MakeComponent("form","app")

CompInit form1

proto="form1"

top=176

left=161

sizeHControl=0

sizeVControl=0

tile=1

caption="Entgeltberechnung fr Kabelanschlu"

End CompInit

Dim Ein as group

Ein = MakeComponent("group",form1)

CompInit Ein

proto="group1"

caption="Eingaben"

look=1

tile=1

tileLayout=1

sizeHControl=3

sizeVControl=3

tileSpacing=6

visible=1

End CompInit

Dim angWE as number

angWE = MakeComponent("number",Ein)

CompInit angWE

proto="angWE"

caption="angWE"

sizeHControl=3

sizeVControl=3

value=1

minimum=1

visible=1

End CompInit

angWE.name="angWE"

Dim maxWE as number

maxWE = MakeComponent("number",Ein)

CompInit maxWE

proto="maxWE"

caption="maxWE"

sizeHControl=3

sizeVControl=3

value=1

minimum=1

visible=1

End CompInit

maxWE.name="maxWE"

Ein.name="Ein"

Dim Aus as group

Aus = MakeComponent("group",form1)

CompInit Aus

proto="group2"

caption="Ausgaben"

look=1

tile=1

sizeHControl=3

sizeVControl=3

tileLayout=1

tileSpacing=6

visible=1

End CompInit

Dim nT as group

nT = MakeComponent("group",Aus)

CompInit nT

proto="group4"

caption="Normaltarif"

height=38

width=100

look=1

tile=1

visible=1

End CompInit

Dim nTnetto as label

nTnetto = MakeComponent("label",nT)

CompInit nTnetto

proto="nTnetto"

caption="nTnetto"

sizeHControl=3

sizeVControl=3

visible=1

End CompInit

nTnetto.name="nTnetto"

Dim nTMWSt as label

nTMWSt = MakeComponent("label",nT)

CompInit nTMWSt

proto="nTMWSt"

caption="nTMWSt"

sizeHControl=3

sizeVControl=3

visible=1

End CompInit

nTMWSt.name="nTMWSt"

Dim nTbrutto as label

nTbrutto = MakeComponent("label",nT)

CompInit nTbrutto

proto="nTbrutto"

caption="nTbrutto"

sizeHControl=3

sizeVControl=3

visible=1

End CompInit

nTbrutto.name="nTbrutto"

nT.name="nT"

Dim pT as group

pT = MakeComponent("group",Aus)

CompInit pT

proto="group5"

caption="Pauschaltarif"

height=43

width=100

look=1

tile=1

visible=1

End CompInit

Dim pTnetto as label

pTnetto = MakeComponent("label",pT)

CompInit pTnetto

proto="pTnetto"

caption="pTnetto"

sizeHControl=3

sizeVControl=3

visible=1

End CompInit

pTnetto.name="pTnetto"

Dim pTMWSt as label

pTMWSt = MakeComponent("label",pT)

CompInit pTMWSt

proto="pTMWSt"

caption="pTMWSt"

sizeHControl=3

sizeVControl=3

visible=1

End CompInit

pTMWSt.name="pTMWSt"

Dim pTbrutto as label

pTbrutto = MakeComponent("label",pT)

CompInit pTbrutto

proto="pTbrutto"

caption="pTbrutto"

sizeHControl=3

sizeVControl=3

visible=1

End CompInit

pTbrutto.name="pTbrutto"

pT.name="pT"

Dim oT as group

oT = MakeComponent("group",Aus)

CompInit oT

proto="group6"

caption="optimaler Tarif"

look=1

tile=1

sizeHControl=3

sizeVControl=0

height=33

visible=1

End CompInit

Dim oTnetto as label

oTnetto = MakeComponent("label",oT)

CompInit oTnetto

proto="oTnetto"

caption="oTnetto"

sizeHControl=3

sizeVControl=3

visible=1

End CompInit

oTnetto.name="oTnetto"

Dim oTMWSt as label

oTMWSt = MakeComponent("label",oT)

CompInit oTMWSt

proto="oTMWSt"

caption="oTMWSt"

sizeHControl=3

sizeVControl=3

visible=1

End CompInit

oTMWSt.name="oTMWSt"

Dim oTbrutto as label

oTbrutto = MakeComponent("label",oT)

CompInit oTbrutto

proto="oTbrutto"

caption="oTbrutto"

sizeHControl=3

sizeVControl=3

visible=1

End CompInit

oTbrutto.name="oTbrutto"

oT.name="oT"

Aus.name="Aus"

Dim Berech as group

Berech = MakeComponent("group",form1)

CompInit Berech

proto="group3"

caption="Berechnung"

look=1

tile=1

sizeHControl=3

sizeVControl=3

tileLayout=1

visible=1

End CompInit

Dim mE as button

mE = MakeComponent("button",Berech)

CompInit mE

proto="mE"

caption="mtl.Entgelt"

sizeHControl=3

sizeVControl=3

visible=1

End CompInit

mE.name="mE"

Dim eE as button

eE = MakeComponent("button",Berech)

CompInit eE

proto="eE"

caption="einm.Entgelt"

sizeHControl=3

sizeVControl=3

visible=1

End CompInit

eE.name="eE"

Berech.name="Berech"

Dim group8 as group

group8 = MakeComponent("group",form1)

CompInit group8

proto="group8"

caption="Infos"

look=1

tile=1

visible=1

End CompInit

Dim label11 as label

label11 = MakeComponent("label",group8)

CompInit label11

proto="label11"

caption="von: Reiner.Dienlin@t-online.de; Stand:  31.08.98"

sizeHControl=3

sizeVControl=3

visible=1

End CompInit

label11.name="label11"

group8.name="group8"

form1.width=213

form1.height=76

form1.name="form1"

EnableEvents()

duplo_start()

end sub



sub duplo_start()

REM place initialization code here



form1.visible = 1							'Tip von Dirk Haase, damit das Programm erfolgreich auch als Kompilat selbst ablauffhig wird



'erste Fassung: 				02.05.98

'berarbeitete Fassung:		31.08.98



'Berechnung des Entgeltes fr Kabelanschlu, Beta-Stadium

'Keine Gewhr





'Reiner Dienlin

'Leonardusstr.86

'53175 Bonn





' Definition globaler Variablen

DIM WE as integer							'WE: WohnEinheiten

DIM TmaxWE as integer						'temporre Variable; maximal versorgbare WE

DIM TangWE as integer						'		-"-			  ; an einen bergabepunkt angeschlossene WE

DIM Betrag as float							'Betrag des Entgeltes in DM

DIM TBetrag as float							'temporre Variable; wie vorstehend



DIM nT_Betrag_m_net as float				'Betrag, monatlich netto im Normal-Tarif; der Normal-Tarif hat die angWE zur Berechnungsbasis

DIM nT_Betrag_m_st as float					'Steuer auf den vorstehenden Betrag

DIM nT_Betrag_m_br as float					'Betrag, monatlich brutto im Normal-Tarif



DIM nT_Betrag_e_net as float				'Betrag, einmalig netto im Normal-Tarif; der Normal-Tarif hat die angWE zur Berechnungsbasis

DIM nT_Betrag_e_st as float					'Steuer auf den vorstehenden Betrag

DIM nT_Betrag_e_br as float					'Betrag, einmalig brutto im Normal-Tarif



DIM pT_Betrag_m_net as float				'Betrag, monatlich netto im Pauschal-Tarif; der Pauschal-Tarif hat die maxWE zur Berechnungsbasis

DIM pT_Betrag_m_st as float					'	... siehe die vorstehenden 2 Blcke, statt Normal- nun den Pauschaltarif

DIM pT_Betrag_m_br as float					'	...



DIM pT_Betrag_e_net as float				'	...

DIM pT_Betrag_e_st as float					'	...

DIM pT_Betrag_e_br as float					'	...



DIM oT_Betrag_e_net as float				'Betrag, monatlich netto, "optimaler" Tarif, d.h. entweder Normal- oder Pauschal-Tarif, je nachdem, was gnstiger ist (Ergebnis ist ein Vergleich der erstgenannten Tarifarten) 

DIM oT_Betrag_e_st as float					'	... siehe die beiden Blcke zum Normal-Tarif

DIM oT_Betrag_e_br as float					'	...



DIM oT_Betrag_m_net as float				'	...

DIM oT_Betrag_m_st as float					'	...

DIM oT_Betrag_m_br as float					'	...





'Definition glober Konstanten				'Das Entgelt fr Kabelanschlu richtet sich nach der Zahl der versorgten WE (angWE) oder nach Zahl der versorgbaren WE (maxWE), je nach Tarifart (normal/pauschal); dabei ist das Entgelt in Abhngigkeit der zu berechnenden WE nicht stetig

DIM y11 as integer							'Konstante fr den ersten Eckwert; hier fr das einmalige Entgelt

y11=1											'Zuweisung, Wert in WE

DIM y20 as float								'Konstante fr den ersten Eckbetrag; hier wieder fr das einmalige Entgelt

y20=56.52										'Zuweisung, Wert in DM netto

DIM y21 as float								'Konstante fr den zweiten Eckwert; ...

y21=586.95

DIM y12 as integer							'Konstante fr den zweiten Eckbetrag; ...

y12=2

DIM y22 as float								'...

y22=391.30

DIM y13 as integer

y13=5

DIM y23 as float

y23=347.82

DIM y14 as integer

y14=6

DIM y24 as float

y24=304.34

DIM y15 as integer

y15=11

DIM y25 as float

y25=21.73

DIM y16 as integer

y16=101

DIM y26 as float

y26=8.69



DIM x11 as integer							'siehe oberen Block, nun alles fr das monatliche Entgelt

x11=1

DIM x20 as float

x20=22.52						'der Ausnahmefall mit 16.95 DM fuer Vertraege, die vor dem 01.07.91 geschlossen wurden, ist nicht programmiert!!!

DIM x21 as float

x21=15.91

DIM x12 as integer

x12=11

DIM x22 as float

x22=14.17

DIM x13 as integer

x13=21

DIM x23 as float

x23=11.21

DIM x14 as integer

x14=41

DIM x24 as float

x24=8.78

DIM x15 as integer

x15=101

DIM x25 as float

x25=5.91

DIM x16 as integer

x16=201

DIM x26 as float

x26=3.91

DIM x17 as integer

x17=501

DIM x27 as float

x27=2.78

DIM x18 as integer

x18=1001

DIM x28 as float

x28=2.17

DIM x19 as integer

x19=2501

DIM x29 as float

x29=1.73



end sub



sub module_goTo(context as string)



end sub



function module_getContext()



module_getContext = ""



end function



sub module_show()

REM code for making this module appear

form1.visible=1



end sub



sub module_hide()

REM code for making this module disappear

form1.visible=0



end sub



sub module_exit()



end sub



sub mE_pressed(self as button)



'Berechnen des monatlichenen Entgeltes fr Kabelanschlu



TmaxWE=maxWE.value							'Zuweisung des Eingabe-Wertes an die temporre Variable

TangWE=angWE.value							'				-"-

IF TmaxWE<TangWE THEN						'falls der Wert der maxWE niedriger als der der angWE ist, mu der Wert der maxWE korrigiert werden

	maxWE.value=TangWE

END IF



WE=5											'der Pauschaltarif betrgt mindestens soviel wie fr 5 WE im Normaltarif!

mEntg(WE)										'deshalb Berechnung des Normaltarifes fr 5 WE und

TBetrag=Betrag								'Zuweisung zur temporren Variablen fr den Betrag



WE=maxWE.value								'Berechnung des Pauschaltarifes; Zuweisung maxWE zur Variablen WE fr den Aufruf der Berechnungsroutine

mEntg(WE)										'Aufruf der Berechnungsroutine

IF Betrag*0.70<TBetrag THEN					'1: der Betrag im Pauschaltarif betrt 0,7 * Normaltarif; 2: fr den Pauschaltarif mu mind. der Betrag fr 5 WE im Normaltarif gezahlt werden

pT_Betrag_m_net=TBetrag						'Zuweisung des Betrages fr 5 WE im Normaltarif an die Ausgabevariable, da der Pauschaltarif noch nicht anwendbar ist

ELSE

pT_Betrag_m_net=Betrag*0.70					'Berechnung und Zuweisung des Pauschaltarifes an die Ausgabevariable

END IF

pT_Betrag_m_st=pT_Betrag_m_net*0.16		'Berechnung und Zuweisung der MWSt an die Ausgabevariable

pT_Betrag_m_br=pT_Betrag_m_net*1.16		'Berechnung und Zuweisung des Bruttobetrages an die Ausgabevariable





pTnetto.caption=str(pT_Betrag_m_net)		'Ausgabe

pTMWSt.caption=str(pT_Betrag_m_st)			' -"-

pTbrutto.caption=str(pT_Betrag_m_br)		' -"-



WE=angWE.value								'Berechnung fr den Normaltarif

mEntg(WE)

nT_Betrag_m_net=Betrag

nT_Betrag_m_st=nT_Betrag_m_net*0.16

nT_Betrag_m_br=nT_Betrag_m_net*1.16



nTnetto.caption=str(nT_Betrag_m_net)

nTMWSt.caption=str(nT_Betrag_m_st)

nTbrutto.caption=str(nT_Betrag_m_br)



IF pT_Betrag_m_net<nT_Betrag_m_net THEN	'Ermittlung des "optimalen" Tarifs/Entgeltes durch Vergleich des Normal- mit dem Pauschaltarif

oT_Betrag_m_net=pT_Betrag_m_net

ELSE

oT_Betrag_m_net=nT_Betrag_m_net

END IF

oT_Betrag_m_st=oT_Betrag_m_net*0.16

oT_Betrag_m_br=oT_Betrag_m_net*1.16



oTnetto.caption=str(oT_Betrag_m_net)		'Ausgabe

oTMWSt.caption=str(oT_Betrag_m_st)

oTbrutto.caption=str(oT_Betrag_m_br)





end sub



sub eE_pressed(self as button)

'Berechnen des einmaligen Entgeltes fr Kabelanschlu

'Kommentierung im einzelnen siehe bei der Berechnung des monatlichen Entgeltes



TmaxWE=maxWE.value

TangWE=angWE.value

IF TmaxWE<TangWE THEN

	maxWE.value=TangWE

END IF



WE=5

eEntg(WE)

TBetrag=Betrag



WE=maxWE.value

eEntg(WE)

IF Betrag*0.70<TBetrag THEN

pT_Betrag_e_net=TBetrag

ELSE

pT_Betrag_e_net=Betrag*0.70

END IF

pT_Betrag_e_st=pT_Betrag_e_net*0.16

pT_Betrag_e_br=pT_Betrag_e_net*1.16





pTnetto.caption=str(pT_Betrag_e_net)

pTMWSt.caption=str(pT_Betrag_e_st)

pTbrutto.caption=str(pT_Betrag_e_br)



WE=angWE.value

eEntg(WE)

nT_Betrag_e_net=Betrag

nT_Betrag_e_st=nT_Betrag_e_net*0.16

nT_Betrag_e_br=nT_Betrag_e_net*1.16



nTnetto.caption=str(nT_Betrag_e_net)

nTMWSt.caption=str(nT_Betrag_e_st)

nTbrutto.caption=str(nT_Betrag_e_br)



IF pT_Betrag_e_net<nT_Betrag_e_net THEN

oT_Betrag_e_net=pT_Betrag_e_net

ELSE

oT_Betrag_e_net=nT_Betrag_e_net

END IF

oT_Betrag_e_st=oT_Betrag_e_net*0.16

oT_Betrag_e_br=oT_Betrag_e_net*1.16



oTnetto.caption=str(oT_Betrag_e_net)

oTMWSt.caption=str(oT_Betrag_e_st)

oTbrutto.caption=str(oT_Betrag_e_br)





end sub



sub eEntg(WE as integer)

' Berechnen des einmaligen Entgelts fr vorgegebenen WE-Wert

' die definierten Eckwerte und Eckbetrge im Modul "module_init" werden in einer vielfach geschachtelten "If-Then-Else"-Routine verarbeitet; eine "While-Wend"-Routine wre viel bersichtlicher und einfacher, leider stehen die Befehle in NewBasic nicht zur Verfgung :-(



Betrag=0.00

IF WE=y11 THEN

	Betrag=y20

ELSE

	IF WE>y11 THEN

		IF WE>y12 THEN

			IF WE>y13 THEN

				IF WE>y14 THEN

					IF WE>y15 THEN

						IF WE>y16 THEN

						Betrag=Betrag+(WE-y16+1)*y26

						WE=y16-1

						END IF

					Betrag=Betrag+(WE-y15+1)*y25

					WE=y15-1

					END IF

				Betrag=Betrag+(WE-y14+1)*y24

				WE=y14-1

				END IF

			Betrag=Betrag+(WE-y13+1)*y23

			WE=y13-1

			END IF

		Betrag=Betrag+(WE-y12+1)*y22

		WE=y12-1

		END IF

	Betrag=Betrag+(WE-y11+1)*y21

	WE=y11-1

	END IF				

END IF



end sub



sub mEntg(WE as integer)

' Berechnen des einmaligen Entgelts fr vorgegebenen WE-Wert

' Kommentar siehe im Routine "eEntg"



Betrag=0.00

IF WE=x11 THEN

	Betrag=x20

ELSE

	IF WE>x11 THEN

		IF WE>x12 THEN

			IF WE>x13 THEN

				IF WE>x14 THEN

					IF WE>x15 THEN

						IF WE>x16 THEN

							IF WE>x17 THEN

								IF WE>x18 THEN

									IF WE>x19 THEN

									Betrag=Betrag+(WE-x19+1)*x29

									WE=x19-1

									END IF

								Betrag=Betrag+(WE-x18+1)*x28

								WE=x18-1

								END IF

							Betrag=Betrag+(WE-x17+1)*x27

							WE=x17-1

							END IF	

						Betrag=Betrag+(WE-x16+1)*x26

						WE=x16-1

						END IF

					Betrag=Betrag+(WE-x15+1)*x25

					WE=x15-1

					END IF

				Betrag=Betrag+(WE-x14+1)*x24

				WE=x14-1

				END IF

			Betrag=Betrag+(WE-x13+1)*x23

			WE=x13-1

			END IF

		Betrag=Betrag+(WE-x12+1)*x22

		WE=x12-1

		END IF

	Betrag=Betrag+(WE-x11+1)*x21

	WE=x11-1

	END IF				

END IF





end sub



