sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=85
left=76
sizeHControl=0
sizeVControl=0
tileSpacing=5
caption="OptoSoft - IARU 0.9"
helpContext="TOC"
helpFile="optoiaru"
End CompInit
Dim button1 as button
button1 = MakeComponent("button",form1)
CompInit button1
proto="button1"
caption="-->"
sizeHControl=3
sizeVControl=3
left=120
top=44
visible=1
End CompInit
button1.name="button1"
Dim group1 as group
group1 = MakeComponent("group",form1)
CompInit group1
proto="group1"
caption="IARU"
left=10
top=10
height=150
width=100
look=1
visible=1
End CompInit
Dim entry1 as entry
entry1 = MakeComponent("entry",group1)
CompInit entry1
proto="entry1"
width=50
maxChars=6
text="JO61UB"
left=25
top=37
sizeVControl=3
visible=1
End CompInit
entry1.name="entry1"
Dim spacer1 as spacer
spacer1 = MakeComponent("spacer",group1)
CompInit spacer1
proto="spacer1"
left=5
top=70
look=5
width=90
visible=1
End CompInit
spacer1.name="spacer1"
Dim label3 as label
label3 = MakeComponent("label",group1)
CompInit label3
proto="label3"
caption="???"
left=29
top=108
visible=1
End CompInit
label3.name="label3"
group1.name="group1"
Dim group2 as group
group2 = MakeComponent("group",form1)
CompInit group2
proto="group2"
caption="Geografische Koordinaten"
left=160
top=9
height=150
width=309
look=1
visible=1
End CompInit
Dim number1 as number
number1 = MakeComponent("number",group2)
CompInit number1
proto="number1"
left=20
top=95
caption=""
sizeHControl=0
sizeVControl=3
width=20
maximum=180
value=123
visible=1
End CompInit
number1.name="number1"
Dim number2 as number
number2 = MakeComponent("number",group2)
CompInit number2
proto="number2"
left=100
top=95
caption=""
sizeHControl=0
sizeVControl=3
width=20
maximum=99
value=6
visible=1
End CompInit
number2.name="number2"
Dim number3 as number
number3 = MakeComponent("number",group2)
CompInit number3
proto="number3"
left=180
top=95
caption=""
sizeHControl=0
sizeVControl=3
width=20
maximum=99
value=30
visible=1
End CompInit
number3.name="number3"
Dim number4 as number
number4 = MakeComponent("number",group2)
CompInit number4
proto="number4"
left=20
top=120
caption=""
sizeHControl=0
sizeVControl=3
width=20
maximum=180
value=49
displayFormat=0
visible=1
End CompInit
number4.name="number4"
Dim number5 as number
number5 = MakeComponent("number",group2)
CompInit number5
proto="number5"
left=100
top=120
caption=""
sizeHControl=0
sizeVControl=3
width=20
maximum=99
value=16
visible=1
End CompInit
number5.name="number5"
Dim number6 as number
number6 = MakeComponent("number",group2)
CompInit number6
proto="number6"
left=180
top=120
caption=""
sizeHControl=0
width=20
sizeVControl=3
maximum=99
value=30
visible=1
End CompInit
number6.name="number6"
Dim spacer2 as spacer
spacer2 = MakeComponent("spacer",group2)
CompInit spacer2
proto="spacer2"
left=6
top=70
look=5
width=300
visible=1
End CompInit
spacer2.name="spacer2"
Dim entry2 as entry
entry2 = MakeComponent("entry",group2)
CompInit entry2
proto="entry2"
left=260
top=95
width=15
maxChars=1
text="W"
filter=36
visible=1
End CompInit
entry2.name="entry2"
Dim entry3 as entry
entry3 = MakeComponent("entry",group2)
CompInit entry3
proto="entry3"
left=260
top=120
width=15
maxChars=1
filter=36
text="N"
visible=1
End CompInit
entry3.name="entry3"
Dim label4 as label
label4 = MakeComponent("label",group2)
CompInit label4
proto="label4"
caption=""
left=65
top=95
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label4.name="label4"
Dim label5 as label
label5 = MakeComponent("label",group2)
CompInit label5
proto="label5"
caption=""
left=65
top=120
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label5.name="label5"
Dim label6 as label
label6 = MakeComponent("label",group2)
CompInit label6
proto="label6"
caption="'"
left=145
top=95
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label6.name="label6"
Dim label7 as label
label7 = MakeComponent("label",group2)
CompInit label7
proto="label7"
caption="'"
left=145
top=120
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label7.name="label7"
Dim label8 as label
label8 = MakeComponent("label",group2)
CompInit label8
proto="label8"
caption="''"
left=225
top=95
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label8.name="label8"
Dim label9 as label
label9 = MakeComponent("label",group2)
CompInit label9
proto="label9"
caption="''"
left=225
top=120
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label9.name="label9"
Dim group3 as group
group3 = MakeComponent("group",group2)
CompInit group3
proto="group3"
caption=""
left=6
top=13
height=61
width=297
look=2
tile=1
visible=1
End CompInit
Dim label1 as label
label1 = MakeComponent("label",group3)
CompInit label1
proto="label1"
caption="?? ??' 30'' ?"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label1.name="label1"
Dim label2 as label
label2 = MakeComponent("label",group3)
CompInit label2
proto="label2"
caption="?? ??' 30'' ?"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label2.name="label2"
group3.name="group3"
group2.name="group2"
Dim button2 as button
button2 = MakeComponent("button",form1)
CompInit button2
proto="button2"
caption="<--"
left=120
top=120
sizeHControl=0
sizeVControl=3
width=26
visible=1
End CompInit
button2.name="button2"
Dim label10 as label
label10 = MakeComponent("label",form1)
CompInit label10
proto="label10"
caption="Thanks to Michael Roek-Ramirez (DF3ZL)"
left=104
top=171
sizeHControl=3
sizeVControl=0
height=10
visible=1
End CompInit
label10.name="label10"
form1.width=496
form1.height=216
form1.name="form1"
EnableEvents()
duplo_start()
end sub

sub duplo_start()

' by OptoSoft - DirkHaase
'
' - IARU <-> Koordinaten o.k.
' - Himmelsrichtungscheck einbauen (nur N, S, O(E), W)

' Werte fuer IARU -> geogr. Koordinaten

dim b8  as string
dim e9  as string
dim e10 as string
dim e11 as string
dim e12 as string
dim e13 as string
dim e14 as string
dim f8  as string
dim f9  as string
dim f10 as string
dim f11 as string
dim f12 as string
dim f13 as string
dim f14 as string
dim g8  as integer
dim g9  as integer
dim g10 as integer
dim g11 as integer
dim g12 as integer
dim g13 as float
dim g14 as integer
dim g15 as string
dim g16 as string
dim g17 as float
dim g19 as string
dim g20 as string
dim h8  as string
dim h9  as string

e9="N"
e10="S"
e11="W"
e12="O"

rem Koordinaten -> IARU

dim a2 as float
dim a3 as float
dim b2 as integer
dim b3 as integer
dim c2 as integer
dim c3 as integer
dim d2 as string
dim d3 as string
dim e7 as integer
dim f3 as float
dim f4 as string
dim f5 as integer
dim f6 as string
dim f7 as string
dim g3 as float
dim g4 as string
dim g5 as integer
dim g6 as string
dim g7 as string
dim h2 as string

rem fuer Entfernungsberechnung

dim x as float
dim pi as float
pi = 3.1415927
dim ent as integer
dim ent1 as float
dim ent2 as float

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub button1_pressed(self as button)

' IARU -> Koordinaten

' Rundung bei g19 noch falsch ! Haengt wahrscheinlich mit dem
' float-Objekt zusammen. Derzeit durch RealRound umgangen.

entry1.text = upper(entry1.text)

b8 = entry1.text
f8 = b8
f9=MID(f8, 1, 1)
g9=(Asc(f9) - 65)*20

if g9 >= 180 then
	e13 = e12
else
	e13 = e11
end if

f10=Mid(f8, 2, 1)
g10=(Asc(f10) - 65)*10

if g10 >= 90 then
	e14 = e9
else
	e14 = e10
end if

f11=Mid(f8, 3, 1)
f12=Mid(f8, 4, 1)
f13=Mid(f8, 5, 1)
f14=Mid(f8, 6, 1)

g8=Len(f8)

g13=(Asc(f13) - 65)*5
g11=(Asc(f11) - 48)*2 + INT(g13/60)
g12=(Asc(f12) - 48)*1
g14=(Asc(f14) - 65)*2.5

if g9+g11 > 180 then
	g15 = Str(g9 + g11 - 180)
else
	g15 = Str(180 - g9 - g11)
end if

if g10+g12 > 90 then
	g16 =Str(g10 + g12 - 90)
else
	g16 =Str(90 - g10 - g12)
end if

if (g11 + g9 + INT(g13)/60) > 180 then
	g17 = g11 + g9 + INT(g13)/60 - 180
else
	g17 = g11 + g9
end if

g19=RealRound((g17 - INT(g17))*60,0)
'g19=Str((g17 - INT(g17))*60)	rem Rundung falsch !
g20=Str(g14)

h8= "L"+chr(138)+"nge: "+g15 + " " + g19 + "' " + "30'' " + e13
h9= "Breite: "+g16 + " " + g20 + "' " + "30'' " + e14

label1.visible = 0
label2.visible = 0
 label1.caption = h8
 label2.caption = h9
label1.visible = 1
label2.visible = 1

end sub

sub button2_pressed(self as button)

rem Koordinaten -> IARU

rem f3 funktioniert noch nicht -> und damit auch f5/f6 nicht !!!
rem g3 funktioniert noch nicht -> und damit auch g5/g6 nicht !!!
rem
rem noch ein Fehler im Float-Objekt ????

entry2.text = upper(entry2.text)
entry3.text = upper(entry3.text)

a2=number1.value		rem Wertuebernahme
b2=number2.value
c2=number3.value
d2=entry2.text
a3=number4.value
b3=number5.value
c3=number6.value
d3=entry3.text

e7=g5 - 2*val(g6)

' -------------------------------------------------------------

if asc(d3) = 83 then					rem wenn d3 = 83 -> Zeichen "S"
 	f3 = (90 - a3)/10 + 65
else
	f3 = (a3 + 90)/10 + 65
end if

' -------------------------------------------------------------

f4=Chr(f3)

f5=10*f3 - 10*int(f3)
f6=Chr(f5 + 48)

f7=Chr(INT((b3*24 + c3*0.4)/60 + 65))

' -------------------------------------------------------------

if asc(d2) = 87 then
	g3 = (180 - a2)/20 + 65
else
	g3 = (a2 + 180)/20 + 65
end if

' -------------------------------------------------------------

g4=Chr(g3)
g5=20*g3 - 20*int(g3)
g6=Chr(INT(g5/2 + 48))
g7=Chr(INT(((b2 + 60*(g5 - 2*Val(g6)))*12 + c2*0.2)/60 + 65))
h2=g4 + f4 + g6 + f6 + g7 + f7 + "  "

label3.caption = h2

end sub

function RealRound(rrvalue as float, rrdigits as integer) as string
	dim lval as integer
	dim lreal as integer
	lreal = len(str(int(rrvalue)))+1+rrdigits
	RealRound = left(str(Round(rrvalue,rrdigits)),lreal)
end function

function upper(input as string) as string

dim counter as integer
dim charter as string

for counter = 1 to len(input)

	charter = mid(input, counter, 1)
	
	if asc(charter) > 96 and asc(charter) < 123
		charter = chr(asc(charter)-32)
	else if charter = chr(138)
		charter = chr(128)
	else if charter = chr(154)
		charter = chr(133)
	else if charter = chr(159)
		charter = chr(134)
	end if

	upper = upper + charter

next counter

end function

